<?php
/**
 *
 * @category        snippets
 * @package         socialBaker
 * @author          Ruud Eisinga - http://www.dev4me.nl/modules-snippets/opensource/socialbaker/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @version         1.0
 * @lastmodified    Date: 2014-12-05
 *
 */
/* -------------------------------------------------------- */

// Must include code to stop this file being access directly
if(defined('WB_PATH') == false) { die("Cannot access this file directly"); }

global $socialDefaults;

$socialDefaults['twitter'] = array (
		'id' 		=> 1,
		'name' 		=> 'Twitter',
		'share' 	=> 'https://twitter.com/intent/tweet?url={URL}&text={STATUS} - {DESCRIPTION}',
		'icon' 		=> 'twitter.png'
	);
$socialDefaults['facebook'] = array (
		'id' 		=> 2,
		'name' 		=> 'Facebook',
		'share' 	=> 'https://www.facebook.com/sharer/sharer.php?u={URL}',
		'icon' 		=> 'facebook.png'
	);
$socialDefaults['googleplus'] = array (
		'id' 		=> 3,
		'name' 		=> 'GooglePlus',
		'share' 	=> 'https://plus.google.com/share?url={URL}',
		'icon' 		=> 'googleplus.png'
	);
$socialDefaults['linkedin'] = array (
		'id' 		=> 4,
		'name' 		=> 'LinkedIn',
		'share' 	=> 'https://www.linkedin.com/shareArticle?mini=true&url={URL}&title={STATUS}&summary={DESCRIPTION}&source=',
		'icon' 		=> 'linkedin.png'
	);

$socialDefaults['digg'] = array (
		'id' 		=> 5,
		'name' 		=> 'Digg',
		'share' 	=> 'http://www.digg.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'digg.png'
	);
	
$socialDefaults['stumbleupon'] = array (
		'id' 		=> 6,
		'name' 		=> 'StumbleUpon',
		'share' 	=> 'http://www.stumbleupon.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'stumbleupon.png'
	);
	
$socialDefaults['delicious'] = array (
		'id' 		=> 7,
		'name' 		=> 'Delicious',
		'share' 	=> 'https://delicious.com/save?v=5&noui&jump=close&url={URL}&title={STATUS}',
		'icon' 		=> 'delicious.png'
	);
$socialDefaults['vk'] = array (
		'id' 		=> 8,
		'name' 		=> 'VKontakte',
		'share' 	=> 'http://vk.com/share.php?url={URL}&title={STATUS}',
		'icon' 		=> 'vk.png'
	);
$socialDefaults['reddit'] = array (
		'id' 		=> 9,
		'name' 		=> 'Reddit',
		'share' 	=> 'http://www.reddit.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'reddit.png'
	);
$socialDefaults['tumblr'] = array (
		'id' 		=> 10,
		'name' 		=> 'Tumblr',
		'share' 	=> 'http://www.tumblr.com/share?v=3&u={URL}&t={STATUS}',
		'icon' 		=> 'tumblr.png'
	);
	
	


function socialBaker($status = null, $imagePath = null, $shares = null) {
	global $socialDefaults, $wb;
	$url = 'http'.($_SERVER['SERVER_PORT'] == 443 ? 's' : '') . '://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	$description = $wb->page_description;
	$image = '';
	if(!$status) $status = PAGE_TITLE; 			// if no status (message) is set use Pagetitle
	if(is_array($status)) {
		if(isset($status['url'])) $url = $status['url'];
		if(isset($status['image'])) $image = $status['image'];
		if(isset($status['description'])) $description = $status['description'];
		if(isset($status['status'])) $status = $status['status']; else $status = PAGE_TITLE;
	}
	if(!$imagePath) $imagePath = WB_URL.'/modules/socialbaker/images/'; // if imagePath is not set, use internal icons
	
	if(!$shares) $shares = $socialDefaults; 	// if shares are not set, use all..
	if(!is_array($shares)) $shares = explode(",",$shares);
			
	$retval = '<div class="socialwrapper">';
	foreach ( $shares as $share ) {
		if(!is_array($share)) { 				//element is just a string or number.. find default values..
			if (is_numeric($share)) {
				foreach ($socialDefaults as $tmp) {
					if($tmp['id'] == $share) {
						$share = $tmp;
						break;
					}
				}
			} elseif(is_string($share)) { 			//element is string, just use it as index of the defaults array
				if(isset($socialDefaults[strtolower($share)])) {
					$share = $socialDefaults[strtolower($share)];
				}
			} 
		}
		if(is_array($share)) {
			$share['share'] = str_ireplace('{URL}',urlencode($url),$share['share']);
			$share['share'] = str_ireplace('{iMAGE}',urlencode($image),$share['share']);
			$share['share'] = str_ireplace('{DESCRIPTION}',urlencode($description),$share['share']);
			$share['share'] = str_ireplace('{STATUS}',urlencode($status),$share['share']);
			$retval .= '<div class="socialbaker"><a class="share '.strtolower($share['name']).'" title="'.$share['name'].'" href="'.$share['share'].'"><img class="shareicon" src="'.$imagePath.$share['icon'].'" alt="'.$share['name'].'" /></a></div>'.PHP_EOL;
		}
	}
	$retval .= '</div>';
	return $retval;
}

?>
